| Home | Libraries | People | FAQ | More

#### write (5 of 6 overloads)

Write a certain amount of data to a stream before returning.

    template<
        typename SyncWriteStream,
        typename Allocator,
        typename CompletionCondition>
    std::size_t write(
        SyncWriteStream & s,
        basic_streambuf< Allocator > & b,
        CompletionCondition completion_condition);

This function is used to write a certain number of bytes of data to a stream. The call will block until one of the following conditions is true:

- All of the data in the supplied `basic_streambuf` has been written.
- The completion_condition function object returns 0.

This operation is implemented in terms of zero or more calls to the stream's write_some function.

###### Parameters

s

  The stream to which the data is to be written. The type must support the SyncWriteStream concept.

b

  The `basic_streambuf` object from which data will be written.

completion_condition

  The function object to be called to determine whether the write operation is complete. The signature of the function object must be:

      std::size_t completion_condition(
        // Result of latest write_some operation.
        const boost::system::error_code& error,

        // Number of bytes transferred so far.
        std::size_t bytes_transferred
      );

  A return value of 0 indicates that the write operation is complete. A non-zero return value indicates the maximum number of bytes to be written on the next call to the stream's write_some function.

###### Return Value

The number of bytes transferred.

###### Exceptions

boost::system::system_error

  Thrown on failure.